SystemOrganization addCategory: #ConfigurationOfHelvetia!

Object subclass: #ConfigurationOfHelvetia
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfHelvetia'!

!ConfigurationOfHelvetia class methodsFor: 'development support' stamp: 'NickPapoulias 9/22/2016 16:07'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>! !

!ConfigurationOfHelvetia class methodsFor: 'private' stamp: 'NickPapoulias 9/22/2016 16:07'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #'ConfigurationOf'
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #'ConfigurationOf' ifAbsent: aBlock ].! !

!ConfigurationOfHelvetia class methodsFor: 'private' stamp: 'NickPapoulias 9/22/2016 16:07'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfHelvetia class methodsFor: 'private' stamp: 'NickPapoulias 9/22/2016 16:07'!
ensureMetacelloBaseConfiguration
  Smalltalk
    at: #'ConfigurationOf'
    ifAbsent: [ 
      | repository version |
      repository := MCHttpRepository
        location: 'http://smalltalkhub.com/mc/dkh/metacello/main'
        user: ''
        password: ''.
      repository
        versionReaderForFileNamed: 'Metacello-Base-dkh.107'
        do: [ :reader | 
          version := reader version.
          version load.
          version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfHelvetia class methodsFor: 'metacello tool support' stamp: 'NickPapoulias 9/22/2016 16:07'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfHelvetia class methodsFor: 'loading' stamp: 'NickPapoulias 9/22/2016 16:07'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfHelvetia class methodsFor: 'loading' stamp: 'NickPapoulias 9/22/2016 16:07'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfHelvetia class methodsFor: 'loading' stamp: 'NickPapoulias 9/22/2016 16:07'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfHelvetia class methodsFor: 'accessing' stamp: 'NickPapoulias 9/22/2016 16:07'!
project

	^self new project! !

!ConfigurationOfHelvetia class methodsFor: 'development support' stamp: 'NickPapoulias 9/22/2016 16:07'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfHelvetia methodsFor: 'baselines' stamp: 'NickPapoulias 10/3/2016 15:41'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/SergeStinckwich/Helvetia/main/'.
		spec 
			package: 'AST-Compiler';
			package: 'AST-Core';
			package: 'AST-Semantic';
			package: 'OpalCompiler-Core';
			package: 'PetitParser';
			package: 'Monticello';
			package: 'QuasiQuote';
			package: 'Helvetia-Core';
			package: #'Cutie-Helvetia' 
				with: [ spec preLoadDoIt: #enableCHCompiler. "spec postLoadDoIt: #disableCHCompiler." ];
			package: 'LanguageBoxes';
			package: 'Cutie-LanguageBoxes' with: [ spec postLoadDoIt: #egRecompile ]
			]
	! !

!ConfigurationOfHelvetia methodsFor: 'accessing' stamp: 'NickPapoulias 9/22/2016 16:07'!
customProjectAttributes
    "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes "

    ^ #()! !

!ConfigurationOfHelvetia methodsFor: 'symbolic versions' stamp: 'NickPapoulias 9/22/2016 16:07'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfHelvetia methodsFor: 'baselines' stamp: 'NickPapoulias 9/22/2016 16:27'!
disableCHCompiler

	CHCompiler disable
! !

!ConfigurationOfHelvetia methodsFor: 'accessing' stamp: 'NickPapoulias 10/3/2016 16:03'!
egRecompile
	
	"some problematic examples that require a double take"

	LBCadrTest recompile.
	LBRomanGrammar recompile.
	LBRomanBoxTest recompile.! !

!ConfigurationOfHelvetia methodsFor: 'baselines' stamp: 'NickPapoulias 9/22/2016 16:27'!
enableCHCompiler

	CHCompiler enable
! !

!ConfigurationOfHelvetia methodsFor: 'accessing' stamp: 'NickPapoulias 9/22/2016 16:07'!
project
    ^ project
        ifNil: [ 
            "Bootstrap Metacello if it is not already loaded"
            self class ensureMetacello.
            project := MetacelloMCProject new projectAttributes: self customProjectAttributes.	"Create the Metacello project"
            (Smalltalk at: #'MetacelloVersionConstructor') on: self project: project.	"Construct the project"
            project loadType: #'linear'.	"change to #atomic if desired"
            project ]! !
